#include "qserver.h"
#include <sys/time.h>
#include <signal.h>

extern char main_buffer [BUFFER_SIZE] ;
extern int link_mask ;

int keys_mask = 1 ;

int ready_for_key = 1 ;

int going = 1 ;

void link_receive () ;
void link_send    () ;

int break_handler (sig)
int sig ;
/*
May need something more sophisticated to deal with
potential deadlocks.
*/
{
  printf ("User break received.  Server terminating.\n") ;
  going = 0 ;
}

void server_body ()
{
  if (HostioInit ())
  {
    signal (SIGINT, break_handler) ;
    while (going)
    {
      int result ;
      int rd_mask = link_mask ;
      
      if (ready_for_key)
      {
        rd_mask |= keys_mask ;
      }
      result = select (32, &rd_mask, 0, 0, 0) ;
      if (rd_mask & keys_mask) 
      {
        char ch ;
        int *out_ptr = (int *) main_buffer ;

        result = read (0, &ch, 1) ;
        if (ch == 10)
          ch = 13 ;
        *(out_ptr++) = f_keyboard ;
        *(out_ptr++) = (int) ch ;
        link_send (main_buffer, ((char *) out_ptr) - main_buffer) ;
        ready_for_key = 0 ;
      }
      if (rd_mask & link_mask)
      {
        int channel ;
        int reply_len ;
        int *in_ptr  = (int *) main_buffer ;

        link_receive (main_buffer, WRITE_HEADER_SIZE) ;

        switch (*(in_ptr++))
        {
          case t_filer :
          {
            reply_len = do_filer (main_buffer, in_ptr) ;
            break ;
          }
          case t_screen :
          {
            reply_len = do_screen (main_buffer, in_ptr) ;
            break ;
          }
          case t_key_ack :
          {
            ready_for_key = 1 ;
            reply_len     = 0 ;
            break ;
          }
          case t_finish :
          {
            int *out_ptr = (int *) main_buffer ;

            *(out_ptr++) = f_finish ;
            reply_len    = ((char *) out_ptr) - main_buffer ;
            printf ("Server terminating.\n") ;
            going        = 0 ;
            break ;
          }
          default :
          {
            printf ("Unknown channel tag: %d.\n", *(--in_ptr)) ;
            reply_len = -1 ;
            break ;
          }
        }

        if (reply_len < 0)
        {
          printf ("Server aborting.\n") ;
          going = 0 ;
        }
        else
          link_send (main_buffer, reply_len) ;
      }
    }
    HostioClose () ;
  }
}
/*
--
--     End of File.
--
*/
